The sixth batch for 1.8.0
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
3c8f12c9
JH
37# Test the binaries we have just built. The tests are kept in
38# t/ subdirectory and are run in 'trash directory' subdirectory.
39if test -z "$TEST_DIRECTORY"
40then
41 # We allow tests to override this, in case they want to run tests
42 # outside of t/, e.g. for running tests on the test library
43 # itself.
44 TEST_DIRECTORY=$(pwd)
45fi
46if test -z "$TEST_OUTPUT_DIRECTORY"
47then
48 # Similarly, override this to store the test-results subdir
49 # elsewhere
50 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
51fi
52GIT_BUILD_DIR="$TEST_DIRECTORY"/..
53
54. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
55export PERL_PATH SHELL_PATH
56
e1970ce4
JH
57# For repeatability, reset the environment to known value.
58LANG=C
899460f3 59LC_ALL=C
d9bdd39e 60PAGER=cat
e1970ce4 61TZ=UTC
c2116a17
JH
62TERM=dumb
63export LANG LC_ALL PAGER TERM TZ
8ff99e74 64EDITOR=:
661bfd13
SL
65# A call to "unset" with no arguments causes at least Solaris 10
66# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
67# deriving from the command substitution clustered with the other
68# ones.
3c8f12c9 69unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 70 my @env = keys %ENV;
730477f1
JL
71 my $ok = join("|", qw(
72 TRACE
73 DEBUG
74 USE_LOOKUP
75 TEST
76 .*_TEST
77 PROVE
78 VALGRIND
342e9ef2 79 PERF_AGGREGATING_LATER
730477f1
JL
80 ));
81 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
82 print join("\n", @vars);
83')
5adf84eb 84unset XDG_CONFIG_HOME
29e55cd5
JH
85GIT_AUTHOR_EMAIL=author@example.com
86GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
87GIT_COMMITTER_EMAIL=committer@example.com
88GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 89GIT_MERGE_VERBOSITY=5
f8246281
JH
90GIT_MERGE_AUTOEDIT=no
91export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
92export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
93export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 94export EDITOR
e1970ce4 95
886a3907
JH
96# Protect ourselves from common misconfiguration to export
97# CDPATH into the environment
98unset CDPATH
99
5565f47c
BW
100unset GREP_OPTIONS
101
3d5c0cc9 102case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1031|2|true)
104 echo "* warning: Some tests will not work if GIT_TRACE" \
105 "is set as to trace on STDERR ! *"
106 echo "* warning: Please set GIT_TRACE to something" \
107 "other than 1, 2 or true ! *"
108 ;;
6ce4e61f
CC
109esac
110
cd3c095c
JH
111# Convenience
112#
113# A regexp to match 5 and 40 hexdigits
114_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
115_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
116
3749fde5
JH
117# Zero SHA-1
118_z40=0000000000000000000000000000000000000000
119
3f4ab627
JH
120# Line feed
121LF='
122'
123
342e9ef2
TR
124export _x05 _x40 _z40 LF
125
e1970ce4
JH
126# Each test should start with something like this, after copyright notices:
127#
128# test_description='Description of this test...
129# This test checks if command xyzzy does the right thing...
130# '
131# . ./test-lib.sh
c2116a17
JH
132[ "x$ORIGINAL_TERM" != "xdumb" ] && (
133 TERM=$ORIGINAL_TERM &&
134 export TERM &&
135 [ -t 1 ] &&
136 tput bold >/dev/null 2>&1 &&
137 tput setaf 1 >/dev/null 2>&1 &&
138 tput sgr0 >/dev/null 2>&1
139 ) &&
55db1df0 140 color=t
e1970ce4 141
e1970ce4
JH
142while test "$#" -ne 0
143do
144 case "$1" in
145 -d|--d|--de|--deb|--debu|--debug)
146 debug=t; shift ;;
886856ab
JH
147 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
148 immediate=t; shift ;;
5e2c08c6 149 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 150 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 151 -h|--h|--he|--hel|--help)
570f3226 152 help=t; shift ;;
e1970ce4
JH
153 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
154 verbose=t; shift ;;
1ece1274 155 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
156 # Ignore --quiet under a TAP::Harness. Saying how many tests
157 # passed without the ok/not ok details is always an error.
158 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
159 --with-dashes)
160 with_dashes=t; shift ;;
55db1df0 161 --no-color)
faa4bc35 162 color=; shift ;;
4e1be63c 163 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 164 valgrind=t; verbose=t; shift ;;
44138559
JS
165 --tee)
166 shift ;; # was handled already
f423ef5f
JK
167 --root=*)
168 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
169 shift ;;
e1970ce4 170 *)
1f729dca 171 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
172 esac
173done
174
1c0cc756
RJ
175if test -n "$color"
176then
55db1df0 177 say_color () {
c2116a17
JH
178 (
179 TERM=$ORIGINAL_TERM
180 export TERM
55db1df0 181 case "$1" in
1c0cc756
RJ
182 error)
183 tput bold; tput setaf 1;; # bold red
184 skip)
185 tput bold; tput setaf 2;; # bold green
186 pass)
187 tput setaf 2;; # green
188 info)
189 tput setaf 3;; # brown
190 *)
191 test -n "$quiet" && return;;
55db1df0
PH
192 esac
193 shift
5099b99d 194 printf "%s" "$*"
55db1df0 195 tput sgr0
b8eecafd 196 echo
c2116a17 197 )
55db1df0
PH
198 }
199else
200 say_color() {
1ece1274 201 test -z "$1" && test -n "$quiet" && return
55db1df0 202 shift
5099b99d 203 echo "$*"
55db1df0
PH
204 }
205fi
206
207error () {
208 say_color error "error: $*"
6e7b5aaf 209 GIT_EXIT_OK=t
55db1df0
PH
210 exit 1
211}
212
213say () {
214 say_color info "$*"
215}
216
570f3226
MB
217test "${test_description}" != "" ||
218error "Test script did not set test_description."
219
220if test "$help" = "t"
221then
222 echo "$test_description"
223 exit 0
224fi
225
4d9d62fa 226exec 5>&1
781f76b1 227exec 6<&0
e1970ce4
JH
228if test "$verbose" = "t"
229then
230 exec 4>&2 3>&1
231else
232 exec 4>/dev/null 3>/dev/null
233fi
234
235test_failure=0
236test_count=0
41ac414e
JH
237test_fixed=0
238test_broken=0
2d84e9fb 239test_success=0
e1970ce4 240
d998bd4a
ÆAB
241test_external_has_tap=0
242
faa4bc35 243die () {
6e7b5aaf
CB
244 code=$?
245 if test -n "$GIT_EXIT_OK"
246 then
247 exit $code
248 else
249 echo >&5 "FATAL: Unexpected exit with code $code"
250 exit 1
251 fi
faa4bc35
CB
252}
253
6e7b5aaf 254GIT_EXIT_OK=
35641310 255trap 'die' EXIT
41184273 256
12a29b1a
TR
257# The user-facing functions are loaded from a separate file so that
258# test_perf subshells can have them too
3c8f12c9 259. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 260
886856ab
JH
261# You are not expected to call test_ok_ and test_failure_ directly, use
262# the text_expect_* functions instead.
263
264test_ok_ () {
d5d9de1b 265 test_success=$(($test_success + 1))
5099b99d 266 say_color "" "ok $test_count - $@"
e1970ce4
JH
267}
268
886856ab 269test_failure_ () {
d5d9de1b 270 test_failure=$(($test_failure + 1))
5099b99d 271 say_color error "not ok - $test_count $1"
bf0dd8a8 272 shift
5099b99d 273 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 274 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
275}
276
41ac414e 277test_known_broken_ok_ () {
41ac414e 278 test_fixed=$(($test_fixed+1))
5099b99d 279 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
280}
281
282test_known_broken_failure_ () {
41ac414e 283 test_broken=$(($test_broken+1))
5099b99d 284 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 285}
886856ab
JH
286
287test_debug () {
8e832ebc 288 test "$debug" = "" || eval "$1"
e1970ce4
JH
289}
290
a7c58f28
JN
291test_eval_ () {
292 # This is a separate function because some tests use
293 # "return" to end a test_expect_success block early.
781f76b1 294 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
295}
296
4d9d62fa 297test_run_ () {
b6b0afdc 298 test_cleanup=:
b586744a 299 expecting_failure=$2
a7c58f28 300 test_eval_ "$1"
b6b0afdc 301 eval_ret=$?
b586744a
JH
302
303 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
304 then
a7c58f28 305 test_eval_ "$test_cleanup"
b586744a 306 fi
1c0cc756
RJ
307 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
308 then
57e1538a
ÆAB
309 echo ""
310 fi
aa0bcf96 311 return "$eval_ret"
4d9d62fa
PR
312}
313
04ece593 314test_skip () {
8586f98b 315 test_count=$(($test_count+1))
04ece593
JH
316 to_skip=
317 for skp in $GIT_SKIP_TESTS
318 do
8586f98b 319 case $this_test.$test_count in
04ece593
JH
320 $skp)
321 to_skip=t
47e67d47 322 break
04ece593
JH
323 esac
324 done
05236a5e
JN
325 if test -z "$to_skip" && test -n "$test_prereq" &&
326 ! test_have_prereq "$test_prereq"
a7bb3940
JS
327 then
328 to_skip=t
329 fi
04ece593
JH
330 case "$to_skip" in
331 t)
07431fc8 332 of_prereq=
05236a5e 333 if test "$missing_prereq" != "$test_prereq"
07431fc8 334 then
05236a5e 335 of_prereq=" of $test_prereq"
07431fc8
JN
336 fi
337
55db1df0 338 say_color skip >&3 "skipping test: $@"
07431fc8 339 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
340 : true
341 ;;
342 *)
343 false
344 ;;
345 esac
346}
347
342e9ef2
TR
348# stub; perf-lib overrides it
349test_at_end_hook_ () {
350 :
351}
352
e1970ce4 353test_done () {
6e7b5aaf 354 GIT_EXIT_OK=t
2d84e9fb 355
1c0cc756
RJ
356 if test -z "$HARNESS_ACTIVE"
357 then
342e9ef2 358 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5
ÆAB
359 mkdir -p "$test_results_dir"
360 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
361
c54e6be7
ML
362 cat >>"$test_results_path" <<-EOF
363 total $test_count
364 success $test_success
365 fixed $test_fixed
366 broken $test_broken
367 failed $test_failure
368
369 EOF
8ef1abe5 370 fi
41ac414e
JH
371
372 if test "$test_fixed" != 0
373 then
5099b99d 374 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
375 fi
376 if test "$test_broken" != 0
377 then
5099b99d 378 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
379 msg="remaining $(($test_count-$test_broken)) test(s)"
380 else
381 msg="$test_count test(s)"
41ac414e 382 fi
e1970ce4 383 case "$test_failure" in
10b94e28 384 0)
5099b99d 385 # Maybe print SKIP message
bf4b7219
RJ
386 if test -n "$skip_all" && test $test_count -gt 0
387 then
388 error "Can't use skip_all after running some tests"
389 fi
5099b99d
ÆAB
390 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
391
1c0cc756
RJ
392 if test $test_external_has_tap -eq 0
393 then
d87bd7c1
RJ
394 if test $test_count -gt 0
395 then
396 say_color pass "# passed all $msg"
397 fi
d998bd4a
ÆAB
398 say "1..$test_count$skip_all"
399 fi
abc5d372
JS
400
401 test -d "$remove_trash" &&
402 cd "$(dirname "$remove_trash")" &&
403 rm -rf "$(basename "$remove_trash")"
404
342e9ef2
TR
405 test_at_end_hook_
406
e1970ce4
JH
407 exit 0 ;;
408
409 *)
1c0cc756
RJ
410 if test $test_external_has_tap -eq 0
411 then
d998bd4a
ÆAB
412 say_color error "# failed $test_failure among $msg"
413 say "1..$test_count"
414 fi
5099b99d 415
e1970ce4
JH
416 exit 1 ;;
417
418 esac
419}
420
e4597aae 421if test -n "$valgrind"
4e1be63c 422then
4e1be63c
JS
423 make_symlink () {
424 test -h "$2" &&
425 test "$1" = "$(readlink "$2")" || {
426 # be super paranoid
427 if mkdir "$2".lock
428 then
429 rm -f "$2" &&
430 ln -s "$1" "$2" &&
431 rm -r "$2".lock
432 else
433 while test -d "$2".lock
434 do
435 say "Waiting for lock on $2."
436 sleep 1
437 done
438 fi
439 }
440 }
441
442 make_valgrind_symlink () {
36bfb0e5
JK
443 # handle only executables, unless they are shell libraries that
444 # need to be in the exec-path. We will just use "#!" as a
445 # guess for a shell-script, since we have no idea what the user
446 # may have configured as the shell path.
447 test -x "$1" ||
448 test "#!" = "$(head -c 2 <"$1")" ||
449 return;
4e1be63c
JS
450
451 base=$(basename "$1")
6cec5c68 452 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
453 # do not override scripts
454 if test -x "$symlink_target" &&
455 test ! -d "$symlink_target" &&
456 test "#!" != "$(head -c 2 < "$symlink_target")"
457 then
458 symlink_target=../valgrind.sh
459 fi
efd92ffd
JS
460 case "$base" in
461 *.sh|*.perl)
462 symlink_target=../unprocessed-script
463 esac
4e1be63c
JS
464 # create the link, or replace it if it is out of date
465 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
466 }
467
468 # override all git executables in TEST_DIRECTORY/..
469 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
470 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 471 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
472 do
473 make_valgrind_symlink $file
474 done
ee0d7bf9
TR
475 # special-case the mergetools loadables
476 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
efd92ffd
JS
477 OLDIFS=$IFS
478 IFS=:
479 for path in $PATH
480 do
481 ls "$path"/git-* 2> /dev/null |
482 while read file
483 do
484 make_valgrind_symlink "$file"
485 done
486 done
487 IFS=$OLDIFS
4e1be63c
JS
488 PATH=$GIT_VALGRIND/bin:$PATH
489 GIT_EXEC_PATH=$GIT_VALGRIND/bin
490 export GIT_VALGRIND
1c0cc756
RJ
491elif test -n "$GIT_TEST_INSTALLED"
492then
e4597aae
MO
493 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
494 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 495 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
496 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
497else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 498 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
499 if ! test -x "$git_bin_dir/git"
500 then
501 if test -z "$with_dashes"
502 then
e4597aae
MO
503 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
504 fi
505 with_dashes=t
506 fi
507 PATH="$git_bin_dir:$PATH"
6cec5c68 508 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
509 if test -n "$with_dashes"
510 then
6cec5c68 511 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 512 fi
4e1be63c 513fi
6cec5c68 514GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 515unset GIT_CONFIG
8bfa6bd6 516GIT_CONFIG_NOSYSTEM=1
3c995beb 517GIT_ATTR_NOSYSTEM=1
8f323c00 518export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 519
5e87eae9
JH
520if test -z "$GIT_TEST_CMP"
521then
522 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
523 then
524 GIT_TEST_CMP="$DIFF -c"
525 else
526 GIT_TEST_CMP="$DIFF -u"
527 fi
528fi
529
6cec5c68 530GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 531export GITPERLLIB
6cec5c68 532test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
533 error "You haven't built things yet, have you?"
534}
e1970ce4 535
ac10a857 536if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 537then
6cec5c68 538 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 539 export GITPYTHONLIB
6cec5c68 540 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
541 error "You haven't built git_remote_helpers yet, have you?"
542 }
543fi
544
1c0cc756
RJ
545if ! test -x "$GIT_BUILD_DIR"/test-chmtime
546then
56cf9806
EW
547 echo >&2 'You need to build test-chmtime:'
548 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
549 exit 1
550fi
551
e1970ce4 552# Test repository
abc5d372 553test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
554test -n "$root" && test="$root/$test"
555case "$test" in
556/*) TRASH_DIRECTORY="$test" ;;
342e9ef2 557 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
f423ef5f 558esac
91c8b825 559test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 560rm -fr "$test" || {
6e7b5aaf 561 GIT_EXIT_OK=t
8d14ac94
JH
562 echo >&5 "FATAL: Cannot prepare test area"
563 exit 1
564}
565
90cff968
AR
566HOME="$TRASH_DIRECTORY"
567export HOME
568
1c0cc756
RJ
569if test -z "$TEST_NO_CREATE_REPO"
570then
342e9ef2
TR
571 test_create_repo "$test"
572else
573 mkdir -p "$test"
574fi
1bd9c648
LW
575# Use -P to resolve symlinks in our working directory so that the cwd
576# in subprocesses like git equals our $PWD (for pathname comparisons).
577cd -P "$test" || exit 1
04ece593 578
d5d9de1b
JS
579this_test=${0##*/}
580this_test=${this_test%%-*}
04ece593
JH
581for skp in $GIT_SKIP_TESTS
582do
47e67d47
MG
583 case "$this_test" in
584 $skp)
55db1df0 585 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 586 skip_all="skip all tests in $this_test"
04ece593
JH
587 test_done
588 esac
589done
f17e9fbb 590
8648732e
BC
591# Provide an implementation of the 'yes' utility
592yes () {
593 if test $# = 0
594 then
595 y=y
596 else
597 y="$*"
598 fi
599
600 while echo "$y"
601 do
602 :
603 done
604}
605
f17e9fbb
JS
606# Fix some commands on Windows
607case $(uname -s) in
608*MINGW*)
609 # Windows has its own (incompatible) sort and find
610 sort () {
611 /usr/bin/sort "$@"
612 }
613 find () {
614 /usr/bin/find "$@"
615 }
5397ea31
JS
616 sum () {
617 md5sum "$@"
618 }
4114156a
JS
619 # git sees Windows-style pwd
620 pwd () {
621 builtin pwd -W
622 }
ee9fb68c 623 # no POSIX permissions
6fd1106a 624 # backslashes in pathspec are converted to '/'
fb9a2bea 625 # exec does not inherit the PID
a94114ad 626 test_set_prereq MINGW
a31d0665
RJ
627 test_set_prereq SED_STRIPS_CR
628 ;;
629*CYGWIN*)
630 test_set_prereq POSIXPERM
a31d0665
RJ
631 test_set_prereq EXECKEEPSPID
632 test_set_prereq NOT_MINGW
633 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
634 ;;
635*)
636 test_set_prereq POSIXPERM
6fd1106a 637 test_set_prereq BSLASHPSPEC
fb9a2bea 638 test_set_prereq EXECKEEPSPID
3ba9ba8f 639 test_set_prereq NOT_MINGW
f17e9fbb
JS
640 ;;
641esac
704a3143 642
b082687c 643( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 644test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 645test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 646test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 647test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 648
bb946bba 649# Can we rely on git's output in the C locale?
30955229
JN
650if test -n "$GETTEXT_POISON"
651then
652 GIT_GETTEXT_POISON=YesPlease
653 export GIT_GETTEXT_POISON
5e9637c6 654 test_set_prereq GETTEXT_POISON
30955229
JN
655else
656 test_set_prereq C_LOCALE_OUTPUT
657fi
bb946bba 658
cabdee2c
JH
659# Use this instead of test_cmp to compare files that contain expected and
660# actual output from git commands that can be translated. When running
661# under GETTEXT_POISON this pretends that the command produced expected
662# results.
663test_i18ncmp () {
664 test -n "$GETTEXT_POISON" || test_cmp "$@"
665}
666
127df8c6
JH
667# Use this instead of "grep expected-string actual" to see if the
668# output from a git command that can be translated either contains an
669# expected string, or does not contain an unwanted one. When running
670# under GETTEXT_POISON this pretends that the command produced expected
671# results.
672test_i18ngrep () {
673 if test -n "$GETTEXT_POISON"
674 then
675 : # pretend success
676 elif test "x!" = "x$1"
677 then
678 shift
679 ! grep "$@"
680 else
681 grep "$@"
682 fi
683}
684
04083f27
JH
685test_lazy_prereq SYMLINKS '
686 # test whether the filesystem supports symbolic links
687 ln -s x y && test -h y
688'
c91cfd19 689
ac39aa61
MG
690test_lazy_prereq CASE_INSENSITIVE_FS '
691 echo good >CamelCase &&
692 echo bad >camelcase &&
693 test "$(cat CamelCase)" != good
694'
695
5b0b5dd4
MG
696test_lazy_prereq UTF8_NFD_TO_NFC '
697 # check whether FS converts nfd unicode to nfc
698 auml=$(printf "\303\244")
699 aumlcdiar=$(printf "\141\314\210")
700 >"$auml" &&
701 case "$(echo *)" in
702 "$aumlcdiar")
703 true ;;
704 *)
705 false ;;
706 esac
707'
708
c91cfd19
ÆAB
709# When the tests are run as root, permission tests will report that
710# things are writable when they shouldn't be.
711test -w / || test_set_prereq SANITY